# LLM Reading List

## General

[Attention is all you need - Łukasz Kaiser](https://www.youtube.com/watch?v=IahPIH7LRbs)

[Can large language models provide useful feedback on research papers? A large-scale empirical analysis](https://arxiv.org/pdf/2310.01783.pdf)

[Benchmark for evaluating code generation performance of LLMs](https://nuprl.github.io/MultiPL-E/)

[Illustrated Transformer - Jay Alammar](https://jalammar.github.io/illustrated-transformer/)

[All you need to know about Attention and Transformers - part 1 - Arjun Sarkar](https://towardsdatascience.com/all-you-need-to-know-about-attention-and-transformers-in-depth-understanding-part-1-552f0b41d021)

[Positional encoding - Hunter Phillips](https://medium.com/@hunter-j-phillips/positional-encoding-7a93db4109e6)

[A tutorial on LLM - Haifeng Li](https://medium.com/@haifengl/a-tutorial-to-llm-f78dd4e82efc) - Meta information about dataset collection, fine-tuning, transfer learning, types of applications where LLM's can be used etc.

[Why multi-head self attention works: math, intuitions and 10+1 hidden insights - AI Summer](https://theaisummer.com/self-attention/) - Really good article

[Retentive network: a successor to transformer for large language models (aug. 2023) - Microsoft Research](https://arxiv.org/abs/2307.08621) - Paper introducing the retention mechanism to substitute attention in Transformers; there is a decent overview of the paper as a Medium post [here](https://medium.com/ai-fusion-labs/retentive-networks-retnet-explained-the-much-awaited-transformers-killer-is-here-6c17e3e8add8)

## Papers
[SIMPLIFYING TRANSFORMER BLOCKS](https://arxiv.org/pdf/2311.01906.pdf)
[Retentive Network: A Successor to Transformer for Large Language Models](https://arxiv.org/pdf/2307.08621.pdf)

## Systems

[Llama.cpp 30B runs with only 6GB of RAM now (CPU)](https://github.com/ggerganov/llama.cpp/discussions/638#discussioncomment-5492916)

## Verification

[LEVER: Learning to Verify Language-to-Code Generation with Execution](https://openreview.net/pdf?id=Gj3zN9zs4v)

[How Effective Are Neural Networks for Fixing Security Vulnerabilities](https://arxiv.org/abs/2305.18607)

# Courses/Tutorials

[Neural Networks: Zero to Hero](https://karpathy.ai/zero-to-hero.html) - A course by Andrej Karpathy on building neural networks, from scratch, in code.

[MIT Deep Learning Book](https://github.com/janishar/mit-deep-learning-book-pdf)]
